﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            Person p1 = new Person("Anderson", 16);
            Person p2 = new Person("Anderson", 14);

            Console.WriteLine(p1 + p2);
        }
    }
}

record Person(string Name, int Age)
{
    public static Person operator +(Person first, Person second)
    {
        if (first.Name != second.Name)
        {
            return first;
        }

        return first with { Age = first.Age + second.Age };
    }
}

record class Person2(string Name, string Email);

#if !NET5_0 && !NET6_0
// .NET 5.0 환경이 아닌 경우 IsExternalInit 클래스를 별도로 정의해서 컴파일 가능하게 만듦
namespace System.Runtime.CompilerServices
{
    public class IsExternalInit
    {
    }
}
#endif

struct Member
{
    public string Name;
    public int Age;

    public static Member operator +(Member first, Member second)
    {
        if (first.Name != second.Name)
        {
            return first;
        }

        return new Member { Name = first.Name, Age = first.Age + second.Age };
    }
}
